# Merlin
[![Build Status](https://ci.csclub.uwaterloo.ca/api/badges/public/mirror/status.svg)](https://ci.csclub.uwaterloo.ca/public/mirror)

This folder contains the code for merlin (which does the actual syncing) and arthur (which sends commands to merlin).

### TODO
- [ ] ensure that the proper permissions (file mode, group, user) are used
- [ ] detect if an rsync process is stuck (\*\*)
- [ ] place each rsync process in a separate cgroup (\*\*\*)

\*\* This is optional. If you decide to implement it, you may want to watch the
stdout/stderr of the rsync process.

\*\*\* I need to do more research into this - don't worry about it for now.

### Completed
- [x] write process manager
- [x] save state (last attempted time, last attempted status) for each repo, and restore state on startup (e.g. use JSON/INI file for each repo)
- [x] calculate difference between the scheduled time of a job and the time at which it actually ran; log this
- [x] add all repos to merlin-config.ini (\*)
- [x] handle termination signals in merlin (SIGINT, SIGTERM); close stopChan for this
- [x] listen on Unix socket in merlin
- [x] implement arthur.go (commands: sync and status)
- [x] allow dynamic reloading in merlin
- [x] use separate log file for each child process (currently sharing stdout/stderr with parent)
- [x] implement zfssync in merlin (just invoke the existing Python script)

\* there are some parts that I don't understand (trace_host, csc-sync-ceph, csc-sync-saltstack, etc)
